
const pi = 3.14159265358979323846

' number of devices you want to monitor.
        const numOfUsers = 2
   


' In statute miles-- set to 6378.7 for km-- 3963 for statue miles-  or whatever measurement you want to use
	const earthRadius = 6378.7

' Number of positions to calculate distances to- edit
	const numDecimals  = 2    ' number of decimal places to show in HS-- also the device value will be 10^numDecimals
	const numPositions = 4    ' number of positions you want to monitor

' Leave alone
dim userID(20)
dim latitudePosition(20)
dim longitudePosition(20)
dim distanceCode(20, 20)
dim dist(20, 20) 
dim positionCode(20)
dim latitudeCode(20)
dim longitudeCode(20)
dim updateTimeCode(20)
dim updateDataCode(20)


' Add your users
' Enter your Google Latitude badge here.
	userID(0) =  "386458xxxxxxxxxxxxxx"
	userID(1) =  "38645xxxxxxxxxxx"
	
' virtual devices in homeseer for user 0
	positionCode(0)   = "Z1"
	latitudeCode(0)   = "Z2"
	longitudeCode(0)  = "Z3"
	updateTimeCode(0)    = "Z4"
	updateDataCode(0)    = "Z5"

' virtual devices in homeseer for user 1
	positionCode(1)  = "Z11"
	latitudeCode(1)  = "Z12"
	longitudeCode(1) = "Z13"
	updateTimeCode(1)    = "Z14"
	updateDataCode(1)    = "Z15"

' virtual devices in homeseer for more user 

' Add your locations- virtual devices for distances to those units
        ' home
	latitudePosition(0) =  52.230392
	longitudePosition(0) = 4.8331226
	distanceCode(0, 0)    = "Z6"
	distanceCode(1, 0)    = "Z16"

        ' vanZaal
	latitudePosition(1) =    52.239543
	longitudePosition(1) =  4.775571
	distanceCode(0, 1)    = "Z7"
	distanceCode(1, 1)    = "Z17"

        ' Onset house
	latitudePosition(2) =   40.737656
	longitudePosition(2) =  -72.667142
	distanceCode(0, 2)    = "Z8"
	distanceCode(1, 2)    = "Z18"

        ' wife's work
        latitudePosition(3) = 49.457502
	longitudePosition(3) =  -70.295605
	distanceCode(0, 3)    = "Z9"
	distanceCode(1, 3)    = "Z19"

       'add more here 

	dim husbandsDistanceToHome        
	dim husbandsDistanceToHisWork    
	dim husbandsDistanceTo1    
	dim husbandsDistanceTo2

	dim wifesDistanceToHome      
	dim wifesDistanceToWork
	dim wifesDistanceTo1    
	dim wifesDistanceTo2


        const weAreDowntTheCapeDeviceCode = "Z50"
        const weAreHomeDeviceCode         = "Z51"
        const weAreOutDeviceCode          = "Z52"
        const weAreATWork                 = "Z53"

dim currentCordinates, latitude, longitude, splitArray, position, lastUpdate, lastUpdateTime, lastUpdateDate

' Do the main loop for each user

for outterCount  = 0 to (numOfUsers - 1)
   set oXML= CreateObject("Microsoft.XMLDOM") 

   oXML.async = False 
   oXML.load("http://www.google.com/latitude/apps/badge/api?user=" & userID(outterCount) & "&type=atom")

   set temp = oXML.getElementsByTagName("georss:point")
   currentCordinates = temp(0).Text
    
   splitArray = split(currentCordinates, " ")

   latitude = splitArray(0)
   longitude = splitArray(1)

  
   
   set temp = oXML.getElementsByTagName("georss:featurename")
   position = temp(0).Text
   
   set temp = oXML.getElementsByTagName("updated")
   lastUpdate = temp(0).Text

   splitArray = split(lastUpdate, "T")

   lastUpdateDate = splitArray(0)
   lastUpdateTime = splitArray(1)

   splitArray = split(lastUpdateTime, "Z")

   lastUpdateTime = splitArray(0)

   ' calculate distances
   for count=0 to (numPositions - 1)
      dist(outterCount, count) = earthRadius  * acos(sin(latitude/57.2958) * sin(latitudePosition(count)/57.2958) + cos(latitude/57.2958) * cos(latitudePosition(count)/57.2958) *  cos(longitudePosition(count)/57.2958 -longitude/57.2958))
      dist(outterCount, count) = round( dist(outterCount, count), numDecimals) 
'TEST     hs.writelog "Google Cordinates", count &  "   " & dist(outterCount, count)

'TEST   hs.SetDeviceValue  distanceCode(outterCount, count), (dist(outterCount, count)* 10^numDecimals) 
'TEST     hs.SetDeviceString distanceCode(outterCount, count), dist(outterCount, count)
   Next


   ' from scott12v- update time of devices
'TEST   If hs.devicestring(updateTimeCode(outterCount)) <> lastupdatetime Then
'TEST      hs.writelog "Google Cordinates", hs.devicestring(updateTimeCode(outterCount)) & " " &  lastupdatetime 
'TEST     hs.SetDeviceLastChange positioncode(outterCount), now()
'TEST        hs.SetDeviceLastChange latitudeCode(outterCount), now()
'TEST      hs.SetDeviceLastChange longitudeCode(outterCount), now()
'TEST      hs.SetDeviceLastChange updateTimeCode(outterCount), now()
'TEST      hs.SetDeviceLastChange updateDataCode(outterCount), now()
'TEST     count = 0
'TEST      for count=0 to (numPositions - 1)
'TEST         hs.SetDeviceLastChange distanceCode(outterCount,count), now()
'TEST      Next
'TEST    End If

'TEST    hs.writelog "Google Cordinates", lastUpdateDate
'TEST     hs.writelog "Google Cordinates", lastUpdateTime

'TEST    hs.SetDeviceString positionCode(outterCount), position
'TEST    hs.SetDeviceString latitudeCode(outterCount), latitude
'TEST    hs.SetDeviceString longitudeCode(outterCount), longitude

'TEST   hs.SetDeviceString updateTimeCode(outterCount), lastUpdateTime
'TEST    hs.SetDeviceString updateDataCode(outterCount), lastUpdateDate
Next


' edit this
	husbandsDistanceToHome        = dist(0,0)
	husbandsDistanceToWork        = dist(0,1)
	husbandsDistanceTo1           = dist(0,2)
	husbandsDistanceTo1           = dist(0,3)

	wifesDistanceToHome      = dist(1,0)
	wifesDistanceToWork      = dist(1,1)
	wifesDistanceTo1         = dist(1,2)
	wifesDistanceTo2         = dist(1,3)

'MsgBox ( husbandsDistanceToHome & " Km" & vbCrLf )

' conditions to check to distances to set virtual devices
'if husbandsDistanceToHome < .2 and wifesDistanceToHome < .09 then     
       ' hs.setDeviceStatus weAreDowntTheCapeDeviceCode , 3
       ' hs.setDeviceStatus weAreHomeDeviceCode         , 2
       ' hs.setDeviceStatus weAreOutDeviceCode          , 3
       ' hs.setDeviceStatus weAreATWork                 , 3
'elseif husbandsDistanceToHisWork < 2 and wifesDistanceToHerWork < .09 then     
       ' hs.setDeviceStatus weAreDowntTheCapeDeviceCode , 3
       ' hs.setDeviceStatus weAreHomeDeviceCode         , 3
       ' hs.setDeviceStatus weAreOutDeviceCode          , 3
       ' hs.setDeviceStatus weAreATWork                 , 2

'end if
	
'Set property's in Housebot	
SetPropertyValue "Positie Jacco.Latitude", latitude
SetPropertyValue "Positie Jacco.Longitude", longitude
SetPropertyValue "Positie Jacco.Place", position
SetPropertyValue "Positie Jacco.Last update Date", lastUpdateDate
SetPropertyValue "Positie Jacco.Last update Time", lastUpdateTime
SetPropertyValue "Positie Jacco.Distance form Home", husbandsDistanceToHome & " Km"
SetPropertyValue "Positie Jacco.Distance from Work", husbandsDistanceToWork & " Km"


Function acos(rad)
If Abs(rad) <> 1 Then
acos = pi/2 - Atn(rad / Sqr(1 - rad * rad))
ElseIf rad = -1 Then
acos = pi
End If
End function

